﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Threading.Tasks;
using Windows.Data.Pdf;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage.Streams;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace PDFPasswordException
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            Loaded += MainPage_Loaded;
        }

        private async void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            //Stream stream = typeof(MainPage).GetTypeInfo().Assembly.GetManifestResourceStream("PDFPasswordException.Assets.Encrypted Document.pdf");
            
            Stream stream = typeof(MainPage).GetTypeInfo().Assembly.GetManifestResourceStream("PDFPasswordException.Assets.error256bit.pdf");
            MemoryStream mStream = new MemoryStream();
            stream.Position = 0;
            stream.CopyTo(mStream);
            IRandomAccessStream randomAccessStream = await ConvertToRandomAccessStream(mStream);
            
            //PdfDocument pdf = await PdfDocument.LoadFromStreamAsync(randomAccessStream, "syncfusion");
            
            PdfDocument pdf = await PdfDocument.LoadFromStreamAsync(randomAccessStream, "amada");
        }

        //Convert the MemoryStream to IRandomAccessStream.
        public async Task<IRandomAccessStream> ConvertToRandomAccessStream(MemoryStream memoryStream)
        {
            byte[] bytes = memoryStream.ToArray();
            var randomAccessStream = new InMemoryRandomAccessStream();
            using (var writer = new DataWriter(randomAccessStream))
            {
                writer.WriteBytes(bytes);
                await writer.StoreAsync();
                await writer.FlushAsync();
                writer.DetachStream();
            }
            randomAccessStream.Seek(0);

            return randomAccessStream;
        }
    }
}
